import { SqlColumnQueryCompiler, SqlTableQueryCompiler, SqlOnDuplicateQueryCompiler, SqlInsertQueryCompiler } from '@spinajs/orm-sql';
import { ICompilerOutput, OrderByBuilder, OrderByQueryCompiler, OnDuplicateQueryBuilder, InsertQueryBuilder, TableExistsCompiler, TableExistsQueryBuilder, TableQueryCompiler, TableQueryBuilder } from '@spinajs/orm';
import { Container, IContainer } from '@spinajs/di';
export declare class SqliteTruncateTableQueryCompiler extends TableQueryCompiler {
    protected container: Container;
    protected builder: TableQueryBuilder;
    constructor(container: Container, builder: TableQueryBuilder);
    compile(): ICompilerOutput;
}
export declare class SqliteOrderByCompiler extends OrderByQueryCompiler {
    protected _builder: OrderByBuilder;
    constructor(builder: OrderByBuilder);
    compile(): ICompilerOutput;
}
export declare class SqliteOnDuplicateQueryCompiler extends SqlOnDuplicateQueryCompiler {
    constructor(builder: OnDuplicateQueryBuilder);
    compile(): {
        bindings: any[];
        expression: string;
    };
}
export declare class SqliteTableExistsCompiler implements TableExistsCompiler {
    protected builder: TableExistsQueryBuilder;
    constructor(builder: TableExistsQueryBuilder);
    compile(): ICompilerOutput;
}
export declare class SqliteTableQueryCompiler extends SqlTableQueryCompiler {
    compile(): ICompilerOutput[];
}
export declare class SqliteInsertQueryCompiler extends SqlInsertQueryCompiler {
    constructor(container: IContainer, builder: InsertQueryBuilder);
    compile(): {
        bindings: any[];
        expression: string;
    };
    protected into(): string;
}
export declare class SqliteColumnCompiler extends SqlColumnQueryCompiler {
    compile(): ICompilerOutput;
    protected _defaultCompiler(): string;
}
//# sourceMappingURL=compilers.d.ts.map