"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SqliteObjectToSqlConverter = exports.SqliteModelToSqlConverter = void 0;
/* eslint-disable security/detect-object-injection */
/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
const orm_1 = require("@spinajs/orm");
class SqliteModelToSqlConverter extends orm_1.ModelToSqlConverter {
    toSql(model) {
        const obj = {};
        const relArr = [...model.ModelDescriptor.Relations.values()];
        model.ModelDescriptor.Columns?.filter((x) => !x.IsForeignKey).forEach((c) => {
            const val = model[c.Name];
            if (!c.PrimaryKey && !c.Nullable && (val === null || val === undefined || val === '')) {
                throw new orm_1.OrmException(`Field ${c.Name} cannot be null`);
            }
            // undefined properties we omit,
            // assume that those values have default value in DB defined,
            // SQLITE does not support DEFAULT keyword in insert statements
            // this way insertquerycompiler will not try to fill DEFAULT in missing data
            if (val === undefined)
                return;
            obj[c.Name] = c.Converter ? c.Converter.toDB(val, model, c, model.ModelDescriptor.Converters.get(c.Name)?.Options) : val;
        });
        for (const val of relArr) {
            if (val.Type === orm_1.RelationType.One) {
                if (model[val.Name].Value) {
                    obj[val.ForeignKey] = model[val.Name].Value.PrimaryKeyValue;
                }
            }
        }
        return obj;
    }
}
exports.SqliteModelToSqlConverter = SqliteModelToSqlConverter;
class SqliteObjectToSqlConverter extends orm_1.ObjectToSqlConverter {
    toSql(model) {
        const sqlModel = {};
        // undefined properties we omit,
        // assume that those values have default value in DB defined,
        // SQLITE does not support DEFAULT keyword in insert statements
        // this way insertquerycompiler will not try to fill DEFAULT in missing data
        Object.keys(model).forEach((key) => {
            if (model[key] !== undefined) {
                sqlModel[key] = model[key];
            }
        });
        return sqlModel;
    }
}
exports.SqliteObjectToSqlConverter = SqliteObjectToSqlConverter;
//# sourceMappingURL=converters.js.map