"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SqliteOrmDriver = exports.SqliteServerResponseMapper = void 0;
const compilers_js_1 = require("./compilers.js");
/* eslint-disable @typescript-eslint/no-explicit-any */
/* eslint-disable @typescript-eslint/no-unsafe-argument */
/* eslint-disable @typescript-eslint/no-unsafe-assignment */
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable @typescript-eslint/no-unsafe-member-access */
/* eslint-disable @typescript-eslint/require-await */
/* eslint-disable prettier/prettier */
const log_common_1 = require("@spinajs/log-common");
__exportStar(require("./compilers.js"), exports);
const orm_1 = require("@spinajs/orm");
const sqlite3_1 = __importDefault(require("sqlite3"));
const orm_sql_1 = require("@spinajs/orm-sql");
const di_1 = require("@spinajs/di");
const statements_js_1 = require("./statements.js");
const exceptions_1 = require("@spinajs/exceptions");
const configuration_1 = require("@spinajs/configuration");
const builders_js_1 = require("./builders.js");
const converters_js_1 = require("./converters.js");
class SqliteServerResponseMapper extends orm_1.ServerResponseMapper {
    read(data, pkName) {
        return {
            LastInsertId: data[0][pkName],
        };
    }
}
exports.SqliteServerResponseMapper = SqliteServerResponseMapper;
let SqliteOrmDriver = class SqliteOrmDriver extends orm_sql_1.SqlDriver {
    constructor() {
        super(...arguments);
        this.executionId = 0;
    }
    executeOnDb(stmt, params, queryContext) {
        const queryParams = params ?? [];
        if (!this.Db) {
            throw new Error('cannot execute sqlite statement, no db connection avaible');
        }
        const tName = `query-${this.executionId++}`;
        this.Log.timeStart(`query-${tName}`);
        return new Promise((resolve, reject) => {
            switch (queryContext) {
                case orm_1.QueryContext.Update:
                case orm_1.QueryContext.Delete:
                    this.Db.run(stmt, ...queryParams, function (err) {
                        if (err) {
                            reject(new orm_1.OrmException(`Failed to execute query: ${stmt}, bindings: ${params ? params.join(',') : 'none'}`, err));
                            return;
                        }
                        resolve({
                            RowsAffected: this.changes,
                        });
                    });
                    break;
                case orm_1.QueryContext.Select:
                case orm_1.QueryContext.Upsert:
                    this.Db.all(stmt, ...queryParams, (err, rows) => {
                        if (err) {
                            reject(new orm_1.OrmException(`Failed to execute query: ${stmt}, bindings: ${params ? params.join(',') : 'none'}`, err));
                            return;
                        }
                        resolve(rows);
                    });
                    break;
                case orm_1.QueryContext.Insert:
                    this.Db.run(stmt, ...queryParams, function (err) {
                        if (err) {
                            if (err.code === 'SQLITE_CONSTRAINT') {
                                reject(new exceptions_1.ResourceDuplicated(err));
                            }
                            else {
                                if (err) {
                                    reject(new orm_1.OrmException(`Failed to execute query: ${stmt}, bindings: ${params ? params.join(',') : 'none'}`, err));
                                    return;
                                }
                            }
                            return;
                        }
                        resolve({
                            RowsAffected: this.changes,
                            LastInsertId: this.lastID,
                        });
                    });
                    break;
                case orm_1.QueryContext.Schema:
                case orm_1.QueryContext.Transaction:
                default:
                    this.Db.run(stmt, ...queryParams, (err, data) => {
                        if (err) {
                            reject(new orm_1.OrmException(`Failed to execute query: ${stmt}, bindings: ${params ? params.join(',') : 'none'}`));
                            return;
                        }
                        resolve(data);
                    });
                    break;
            }
        })
            .then((val) => {
            const tDiff = this.Log.timeEnd(`query-${tName}`);
            void this.Log.write({
                Level: log_common_1.LogLevel.Trace,
                Variables: {
                    error: null,
                    message: `Executed: ${stmt}, bindings: ${params ? params.join(',') : 'none'}`,
                    logger: this.Log.Name,
                    level: 'TRACE',
                    duration: tDiff,
                },
            });
            return val;
        })
            .catch((err) => {
            const tDiff = this.Log.timeEnd(`query-${tName}`);
            void this.Log.write({
                Level: log_common_1.LogLevel.Error,
                Variables: {
                    error: err,
                    message: `Failed: ${stmt}, bindings: ${params ? params.join(',') : 'none'}`,
                    logger: this.Log.Name,
                    level: 'Error',
                    duration: tDiff,
                },
            });
            throw err;
        });
    }
    async ping() {
        return this.Db !== null && this.Db !== undefined;
    }
    async connect() {
        return new Promise((resolve, reject) => {
            this.Db = new sqlite3_1.default.Database((0, configuration_1.format)({}, this.Options.Filename), (err) => {
                if (err) {
                    reject(err);
                    return;
                }
                resolve(this);
            });
        });
    }
    async disconnect() {
        if (!this.Db) {
            return;
        }
        return new Promise((resolve, reject) => {
            this.Db.close((err) => {
                if (err) {
                    reject(err);
                    return;
                }
                this.Db = null;
                resolve(this);
            });
        });
    }
    resolve() {
        super.resolve();
        this.Container.register(compilers_js_1.SqliteColumnCompiler).as(orm_1.ColumnQueryCompiler);
        this.Container.register(compilers_js_1.SqliteTableQueryCompiler).as(orm_1.TableQueryCompiler);
        this.Container.register(compilers_js_1.SqliteOrderByCompiler).as(orm_1.OrderByQueryCompiler);
        this.Container.register(statements_js_1.SqlLiteJoinStatement).as(orm_1.JoinStatement);
        this.Container.register(compilers_js_1.SqliteOnDuplicateQueryCompiler).as(orm_1.OnDuplicateQueryCompiler);
        this.Container.register(compilers_js_1.SqliteInsertQueryCompiler).as(orm_1.InsertQueryCompiler);
        this.Container.register(compilers_js_1.SqliteTableExistsCompiler).as(orm_1.TableExistsCompiler);
        this.Container.register(builders_js_1.SqlLiteDefaultValueBuilder).as(orm_1.DefaultValueBuilder);
        this.Container.register(compilers_js_1.SqliteTruncateTableQueryCompiler).as(orm_1.TruncateTableQueryCompiler);
        this.Container.register(converters_js_1.SqliteModelToSqlConverter).as(orm_1.ModelToSqlConverter);
        this.Container.register(converters_js_1.SqliteObjectToSqlConverter).as(orm_1.ObjectToSqlConverter);
        this.Container.register(SqliteServerResponseMapper).as(orm_1.ServerResponseMapper);
    }
    async transaction(qrOrCallback) {
        if (!qrOrCallback) {
            return;
        }
        await this.executeOnDb('BEGIN TRANSACTION', null, orm_1.QueryContext.Transaction);
        try {
            if (Array.isArray(qrOrCallback)) {
                for (const q of qrOrCallback) {
                    await q;
                }
            }
            else {
                await qrOrCallback(this);
            }
            await this.executeOnDb('COMMIT', null, orm_1.QueryContext.Transaction);
        }
        catch (ex) {
            await this.executeOnDb('ROLLBACK', null, orm_1.QueryContext.Transaction);
            throw ex;
        }
    }
    /**
     *
     * Retrieves information about specific DB table if exists. If table not exists returns null
     *
     * @param name - table name to retrieve info
     * @param _schema - optional schema name
     */
    async tableInfo(name, _schema) {
        const converters = this.Container.get('__orm_db_value_converters__');
        const tblInfo = (await this.executeOnDb(`PRAGMA table_info(${name});`, null, orm_1.QueryContext.Select));
        if (!tblInfo || !Array.isArray(tblInfo) || tblInfo.length === 0) {
            return null;
        }
        // get all indices for table
        const indexList = (await this.executeOnDb(`PRAGMA index_list("${name}")`, null, orm_1.QueryContext.Select));
        let uIndices = [];
        // get all unique & fetch for whitch column
        for (const idx of indexList.filter((i) => i.unique === 1)) {
            const iInfo = (await this.executeOnDb(`PRAGMA index_info("${idx.name}")`, null, orm_1.QueryContext.Select));
            uIndices = iInfo.map((x) => x.name);
        }
        // get all foreign keys
        const foreignKeys = (await this.executeOnDb(`PRAGMA foreign_key_list("${name}")`, null, orm_1.QueryContext.Select));
        return tblInfo.map((r) => {
            const fk = foreignKeys.find((i) => i.from === r.name);
            const converter = converters.get(r.type.toLocaleLowerCase());
            return {
                Type: r.type,
                MaxLength: -1,
                Comment: '',
                DefaultValue: converter ? this.Container.resolve(converters.get(r.type.toLocaleLowerCase())).fromDB(r.dflt_value) : r.dflt_value,
                NativeType: r.type,
                Unsigned: false,
                Nullable: r.notnull === 0,
                PrimaryKey: r.pk === 1,
                Uuid: false,
                Ignore: false,
                IsForeignKey: fk !== undefined,
                ForeignKeyDescription: fk
                    ? {
                        From: fk.from,
                        Table: fk.table,
                        To: fk.to,
                    }
                    : null,
                // simply assumpt that integer pkeys are autoincement / auto fill  by default
                AutoIncrement: r.pk === 1 && r.type === 'INTEGER',
                Name: r.name,
                Converter: null,
                Schema: _schema ? _schema : this.Options.Database,
                Unique: uIndices.find((i) => i.includes(r.name)) !== undefined,
            };
        });
    }
};
exports.SqliteOrmDriver = SqliteOrmDriver;
exports.SqliteOrmDriver = SqliteOrmDriver = __decorate([
    (0, di_1.Injectable)('orm-driver-sqlite'),
    (0, di_1.NewInstance)()
], SqliteOrmDriver);
//# sourceMappingURL=index.js.map